	MODULE CLOUDRAIN_MOD	
C
C------------------------------------------------------------------------
C 	SAME AS OLD COMMON/CLOUDRAIN/
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	IMPLICIT NONE
C
C
	REAL (KIND=8) , ALLOCATABLE , SAVE :: LCVPFLX1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SCVPFLX1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: LSTPFLX1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SSTPFLX1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: LCVPFLX2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SCVPFLX2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: LSTPFLX2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SSTPFLX2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: LCVPFLX3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SCVPFLX3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: LSTPFLX3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SSTPFLX3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: LCVPFLX4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SCVPFLX4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: LSTPFLX4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SSTPFLX4(:,:,:)		
C
	CONTAINS
C
	SUBROUTINE ALLOC_CLOUDRAIN
C
	USE PARADI_MOD
C
C-- NEC: initialisation forcee a 0.0 :
	ALLOCATE (LCVPFLX1(LONM1,LATM1,NIVM1)) ; LCVPFLX1(:,:,:) = 0.0
	ALLOCATE (SCVPFLX1(LONM1,LATM1,NIVM1)) ; SCVPFLX1(:,:,:) = 0.0
	ALLOCATE (LSTPFLX1(LONM1,LATM1,NIVM1)) ; LSTPFLX1(:,:,:) = 0.0
	ALLOCATE (SSTPFLX1(LONM1,LATM1,NIVM1)) ; SSTPFLX1(:,:,:) = 0.0
	ALLOCATE (LCVPFLX2(LONM2,LATM2,NIVM2)) ; LCVPFLX2(:,:,:) = 0.0
	ALLOCATE (SCVPFLX2(LONM2,LATM2,NIVM2)) ; SCVPFLX2(:,:,:) = 0.0
	ALLOCATE (LSTPFLX2(LONM2,LATM2,NIVM2)) ; LSTPFLX2(:,:,:) = 0.0
	ALLOCATE (SSTPFLX2(LONM2,LATM2,NIVM2)) ; SSTPFLX2(:,:,:) = 0.0
	ALLOCATE (LCVPFLX3(LONM3,LATM3,NIVM3)) ; LCVPFLX3(:,:,:) = 0.0
	ALLOCATE (SCVPFLX3(LONM3,LATM3,NIVM3)) ; SCVPFLX3(:,:,:) = 0.0
	ALLOCATE (LSTPFLX3(LONM3,LATM3,NIVM3)) ; LSTPFLX3(:,:,:) = 0.0
	ALLOCATE (SSTPFLX3(LONM3,LATM3,NIVM3)) ; SSTPFLX3(:,:,:) = 0.0
	ALLOCATE (LCVPFLX4(LONM4,LATM4,NIVM4)) ; LCVPFLX4(:,:,:) = 0.0
	ALLOCATE (SCVPFLX4(LONM4,LATM4,NIVM4)) ; SCVPFLX4(:,:,:) = 0.0
	ALLOCATE (LSTPFLX4(LONM4,LATM4,NIVM4)) ; LSTPFLX4(:,:,:) = 0.0
	ALLOCATE (SSTPFLX4(LONM4,LATM4,NIVM4)) ; SSTPFLX4(:,:,:) = 0.0
C
C
	END SUBROUTINE ALLOC_CLOUDRAIN
C
	SUBROUTINE DEALLOC_CLOUDRAIN
C
	IF (ALLOCATED(LCVPFLX1)) DEALLOCATE (LCVPFLX1)
	IF (ALLOCATED(SCVPFLX1)) DEALLOCATE (SCVPFLX1)
	IF (ALLOCATED(LSTPFLX1)) DEALLOCATE (LSTPFLX1)
	IF (ALLOCATED(SSTPFLX1)) DEALLOCATE (SSTPFLX1)
	IF (ALLOCATED(LCVPFLX2)) DEALLOCATE (LCVPFLX2)
	IF (ALLOCATED(SCVPFLX2)) DEALLOCATE (SCVPFLX2)
	IF (ALLOCATED(LSTPFLX2)) DEALLOCATE (LSTPFLX2)
	IF (ALLOCATED(SSTPFLX2)) DEALLOCATE (SSTPFLX2)
	IF (ALLOCATED(LCVPFLX3)) DEALLOCATE (LCVPFLX3)
	IF (ALLOCATED(SCVPFLX3)) DEALLOCATE (SCVPFLX3)
	IF (ALLOCATED(LSTPFLX3)) DEALLOCATE (LSTPFLX3)
	IF (ALLOCATED(SSTPFLX3)) DEALLOCATE (SSTPFLX3)
	IF (ALLOCATED(LCVPFLX4)) DEALLOCATE (LCVPFLX4)
	IF (ALLOCATED(SCVPFLX4)) DEALLOCATE (SCVPFLX4)
	IF (ALLOCATED(LSTPFLX4)) DEALLOCATE (LSTPFLX4)
	IF (ALLOCATED(SSTPFLX4)) DEALLOCATE (SSTPFLX4)
C

	END SUBROUTINE DEALLOC_CLOUDRAIN
C
	END MODULE CLOUDRAIN_MOD
