	MODULE CSTES_MOD
C
C------------------------------------------------------------------------
C 	CONSTANTS
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	IMPLICIT NONE
C
C
	INTEGER , SAVE :: NPCL01,NPCL02
	REAL (KIND=8) , SAVE :: MAIR
	REAL (KIND=8) , SAVE :: GG,RA,CP,OMEGA,RTER,PREF,RLATLIM
	REAL (KIND=8) , SAVE :: XPI,XPI2,XPIH,CONV,RTER2,DEUOMG
	REAL (KIND=8) , SAVE :: XLL,TREF,RDT,RTT,ZGAUSS
	REAL (KIND=8) , SAVE :: RD,RV,CPD,CPV,ZEPSNEB,ZEPSDS
	REAL (KIND=8) , SAVE :: QSNEBS,QSNEBC,QSSUSS,QSSUSC,QSSC
	REAL (KIND=8) , SAVE :: QSUSX,HUCOE,HUTIL
	REAL (KIND=8) , SAVE :: XAVOG
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PHUC(:)
C
	INTEGER :: NPROCS,MYID,IERR,MASTER
#ifdef MPI
	INTEGER :: MPI_COMM_MOCAGE
	INTEGER , ALLOCATABLE , SAVE :: I_DEB(:),I_FIN(:)
#endif
C
	CONTAINS
C
	SUBROUTINE ALLOC_CSTES
C
	USE PARADI_MOD
C
#ifdef NIV_91
#define CPP_PHUC 91
#endif
#ifdef NIV_60
#define CPP_PHUC 60
#endif
#ifdef NIV_47
#define CPP_PHUC 47
#endif
C
	ALLOCATE (PHUC(CPP_PHUC)) ; PHUC(:) = 0.0
#ifdef MPI
	ALLOCATE (I_DEB(0:NPROCS-1)) ; I_DEB(:) = 0
	ALLOCATE (I_FIN(0:NPROCS-1)) ; I_FIN(:) = 0
#endif
C
	END SUBROUTINE ALLOC_CSTES
C
	SUBROUTINE DEALLOC_CSTES
C
	DEALLOCATE (PHUC)
#ifdef MPI
	DEALLOCATE (I_DEB)
	DEALLOCATE (I_FIN)
#endif
C
	END SUBROUTINE DEALLOC_CSTES
C
	END MODULE CSTES_MOD
