       SUBROUTINE DECALPIC(LON,LAT,NEMI,NHOUR,RLON,RLAT,EMINAM,EM)
C
C Subroutine de modifictaion du profil des missions
C anthropiques sur la France (decalage identifie dans
C l'inventaire EMEP)
C        
C
       USE CSTES_MOD
C
       IMPLICIT NONE
C
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
       INTEGER :: LON,LAT,NEMI,NHOUR
       REAL (KIND=8) , DIMENSION (LON) :: RLON
       REAL (KIND=8) , DIMENSION (LON) :: RLAT
       CHARACTER(LEN=15) , DIMENSION (NEMI) :: EMINAM
       REAL (KIND=8) , DIMENSION(LON,LAT,NEMI,0:NHOUR) :: EM
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
       INTEGER :: ILON,ILAT,IHOUR,IEMI
       INTEGER :: LONDEB,LATDEB,LONFIN,LATFIN
       INTEGER :: NBHAU1,NBBAS1,NBHAU2,NBBAS2
       REAL (KIND=8) :: RLONDEB,RLATDEB,RLONFIN,RLATFIN
       REAL (KIND=8) :: VALHAU1,VALBAS1,VALHAU2,VALBAS2
       REAL (KIND=8) :: TOTJOUR,COEF
C
C
C Actuellement, le profil est tel qu'il est  une valeur haute 
C de 8h a 19h (soit 12 chances) inclus et une valeur basse 
C le reste du temps
C L'exprience montre qu'il vaut mieux mettre la valeur haute de 
C 5h a 17h inclus (cf A. Dufour)(soit 13 chances)
C On repondere donc les valeurs hautes et valeurs basses 
C pour que le total mis sur la journe soit le mme.
C Ceci est appliqu sur un carr territorial francais
C
       RLONDEB=-6./CONV
       RLONFIN=10./CONV
       RLATDEB=42./CONV
       RLATFIN=50./CONV
C       
       DO ILON=1,LON
        IF (RLON(ILON).LE.RLONDEB) THEN
         LONDEB=ILON
        ENDIF
       ENDDO 
        DO ILON=LON,1,-1
        IF (RLON(ILON).GE.RLONFIN) THEN
         LONFIN=ILON
        ENDIF
       ENDDO 
       DO ILAT=1,LAT
        IF (RLAT(ILAT).LE.RLATDEB) THEN
         LATDEB=ILAT
        ENDIF
       ENDDO 
        DO ILAT=LAT,1,-1
        IF (RLAT(ILAT).GE.RLATFIN) THEN
         LATFIN=ILAT
        ENDIF
       ENDDO 
C
       DO IEMI=1,NEMI
C       
        IF ( ( EMINAM(IEMI) .NE. 'ISO' ) .AND.
     +       ( EMINAM(IEMI) .NE. 'ALPI') .AND.
     +       ( EMINAM(IEMI) .NE. 'LIM' ) ) THEN
C             
         DO ILAT=LATDEB,LATFIN
          DO ILON=LONDEB,LONFIN
C          
           VALHAU1 = EM(ILON,ILAT,IEMI,12)
           VALBAS1 = EM(ILON,ILAT,IEMI,0)
C
           NBBAS1=12
           NBHAU1=12
C
           NBBAS2=11
           NBHAU2=24-NBBAS2
C            
          TOTJOUR=REAL(NBHAU1)*VALHAU1+REAL(NBBAS1)*VALBAS1
C            
C           On a aussi TOTJOUR=NBHAU2*VALHAU2+NBBAS2*VALBAS2
C           On maintient constant le rapport des valeurs haute/basse
C           
           IF (VALBAS1.NE.0.) THEN 
C                   
            COEF = VALHAU1/VALBAS1
            VALBAS2 = TOTJOUR/ ( COEF * REAL(NBHAU2) + REAL(NBBAS2) )
            VALHAU2 = COEF * VALBAS2
C
           ELSE
C                   
           VALBAS2 = 0.
           VALHAU2 = TOTJOUR/ REAL(NBHAU2)
C
           ENDIF
C
           DO IHOUR=5,17
            EM(ILON,ILAT,IEMI,IHOUR)=VALHAU2
           ENDDO
           DO IHOUR=0,4
             EM(ILON,ILAT,IEMI,IHOUR)=VALBAS2
           ENDDO
           DO IHOUR=18,23
            EM(ILON,ILAT,IEMI,IHOUR)=VALBAS2
           ENDDO
C fin boucles lon,lat           
          ENDDO
         ENDDO
C fin test sur les espces        
        ENDIF
C fin boucle espces
       ENDDO
C
C
       RETURN
       END
