	MODULE FORMT_MOD

!------------------------------------------------------------------------
! 	FORCINGS AT CURRENT TIMESTEP (MODEL GRIDS)
!
!	AUTHOR	: HERVE LE BERRE	- CERFACS -
!	DATE		: 03/08/2005
!	VERSION	: 1_0_0
!-----------------------------------------------------------------------

	IMPLICIT NONE


	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: PSOLM1(:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: XPAM1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: XPHFM1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: TGRIM1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: UGRIM1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: VGRIM1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: WGRIM1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIM1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PVGRIM1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DIVQM1(:,:,:),DIVUM1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: FCC1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: FCCV1(:,:,:),QLIQ1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QICE1(:,:,:) 
	
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: PSOLM2(:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: XPAM2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: XPHFM2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: TGRIM2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: UGRIM2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: VGRIM2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: WGRIM2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIM2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PVGRIM2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DIVQM2(:,:,:),DIVUM2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: FCC2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: FCCV2(:,:,:),QLIQ2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QICE2(:,:,:)
	
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: PSOLM3(:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: XPAM3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: XPHFM3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: TGRIM3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: UGRIM3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: VGRIM3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: WGRIM3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIM3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PVGRIM3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DIVQM3(:,:,:),DIVUM3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: FCC3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: FCCV3(:,:,:),QLIQ3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QICE3(:,:,:)
	
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: PSOLM4(:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: XPAM4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: XPHFM4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: TGRIM4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: UGRIM4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: VGRIM4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , TARGET, SAVE :: WGRIM4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIM4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PVGRIM4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DIVQM4(:,:,:),DIVUM4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: FCC4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: FCCV4(:,:,:),QLIQ4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QICE4(:,:,:)

	CONTAINS

	SUBROUTINE ALLOC_FORMT

	USE PARADI_MOD

	ALLOCATE (PSOLM1(LONM1,LATM1))       
	ALLOCATE (XPAM1(LONM1,LATM1,NIVM1))  
	ALLOCATE (XPHFM1(LONM1,LATM1,NIVM1)) 
	ALLOCATE (UGRIM1(LONM1,LATM1,NIVM1)) 
	ALLOCATE (VGRIM1(LONM1,LATM1,NIVM1)) 
	ALLOCATE (WGRIM1(LONM1,LATM1,NIVM1)) 
	ALLOCATE (TGRIM1(LONM1,LATM1,NIVM1)) 
	ALLOCATE (QGRIM1(LONM1,LATM1,NIVM1)) 
	ALLOCATE (PVGRIM1(LONM1,LATM1,NIVM1))
	ALLOCATE (DIVQM1(LONM1,LATM1,NIVM1)) 
	ALLOCATE (DIVUM1(LONM1,LATM1,NIVM1)) 
	ALLOCATE (FCC1(LONM1,LATM1,NIVM1))   
	ALLOCATE (FCCV1(LONM1,LATM1,NIVM1))  
	ALLOCATE (QLIQ1(LONM1,LATM1,NIVM1))  
	ALLOCATE (QICE1(LONM1,LATM1,NIVM1))  

        ALLOCATE (PSOLM2(LONM2,LATM2))       
        ALLOCATE (XPAM2(LONM2,LATM2,NIVM2))  
        ALLOCATE (XPHFM2(LONM2,LATM2,NIVM2)) 
        ALLOCATE (UGRIM2(LONM2,LATM2,NIVM2)) 
        ALLOCATE (VGRIM2(LONM2,LATM2,NIVM2)) 
        ALLOCATE (WGRIM2(LONM2,LATM2,NIVM2)) 
        ALLOCATE (TGRIM2(LONM2,LATM2,NIVM2)) 
        ALLOCATE (QGRIM2(LONM2,LATM2,NIVM2)) 
        ALLOCATE (PVGRIM2(LONM2,LATM2,NIVM2))
        ALLOCATE (DIVQM2(LONM2,LATM2,NIVM2)) 
        ALLOCATE (DIVUM2(LONM2,LATM2,NIVM2)) 
        ALLOCATE (FCC2(LONM2,LATM2,NIVM2))   
        ALLOCATE (FCCV2(LONM2,LATM2,NIVM2))  
        ALLOCATE (QLIQ2(LONM2,LATM2,NIVM2))  
        ALLOCATE (QICE2(LONM2,LATM2,NIVM2))  

        ALLOCATE (PSOLM3(LONM3,LATM3))       
        ALLOCATE (XPAM3(LONM3,LATM3,NIVM3))  
        ALLOCATE (XPHFM3(LONM3,LATM3,NIVM3)) 
        ALLOCATE (UGRIM3(LONM3,LATM3,NIVM3))
        ALLOCATE (VGRIM3(LONM3,LATM3,NIVM3)) 
        ALLOCATE (WGRIM3(LONM3,LATM3,NIVM3)) 
        ALLOCATE (TGRIM3(LONM3,LATM3,NIVM3)) 
        ALLOCATE (QGRIM3(LONM3,LATM3,NIVM3)) 
        ALLOCATE (PVGRIM3(LONM3,LATM3,NIVM3))
        ALLOCATE (DIVQM3(LONM3,LATM3,NIVM3)) 
        ALLOCATE (DIVUM3(LONM3,LATM3,NIVM3)) 
        ALLOCATE (FCC3(LONM3,LATM3,NIVM3))
        ALLOCATE (FCCV3(LONM3,LATM3,NIVM3))  
        ALLOCATE (QLIQ3(LONM3,LATM3,NIVM3))  
        ALLOCATE (QICE3(LONM3,LATM3,NIVM3))  

        ALLOCATE (PSOLM4(LONM4,LATM4))       
        ALLOCATE (XPAM4(LONM4,LATM4,NIVM4))  
        ALLOCATE (XPHFM4(LONM4,LATM4,NIVM4)) 
        ALLOCATE (UGRIM4(LONM4,LATM4,NIVM4)) 
        ALLOCATE (VGRIM4(LONM4,LATM4,NIVM4)) 
        ALLOCATE (WGRIM4(LONM4,LATM4,NIVM4)) 
        ALLOCATE (TGRIM4(LONM4,LATM4,NIVM4)) 
        ALLOCATE (QGRIM4(LONM4,LATM4,NIVM4)) 
        ALLOCATE (PVGRIM4(LONM4,LATM4,NIVM4))
        ALLOCATE (DIVQM4(LONM4,LATM4,NIVM4)) 
        ALLOCATE (DIVUM4(LONM4,LATM4,NIVM4)) 
        ALLOCATE (FCC4(LONM4,LATM4,NIVM4))   
        ALLOCATE (FCCV4(LONM4,LATM4,NIVM4))  
        ALLOCATE (QLIQ4(LONM4,LATM4,NIVM4))  
        ALLOCATE (QICE4(LONM4,LATM4,NIVM4))  

!-- NEC: initialisation forcee a 0.0:
!$omp parallel sections default(shared)
!$omp section
	PSOLM1 (1:LONM1,1:LATM1)         = 0.0
	XPAM1  (1:LONM1,1:LATM1,1:NIVM1) = 0.0
	XPHFM1 (1:LONM1,1:LATM1,1:NIVM1) = 0.0
	UGRIM1 (1:LONM1,1:LATM1,1:NIVM1) = 0.0
	VGRIM1 (1:LONM1,1:LATM1,1:NIVM1) = 0.0
	WGRIM1 (1:LONM1,1:LATM1,1:NIVM1) = 0.0
	TGRIM1 (1:LONM1,1:LATM1,1:NIVM1) = 0.0
	QGRIM1 (1:LONM1,1:LATM1,1:NIVM1) = 0.0
	PVGRIM1(1:LONM1,1:LATM1,1:NIVM1) = 0.0
	DIVQM1 (1:LONM1,1:LATM1,1:NIVM1) = 0.0
	DIVUM1 (1:LONM1,1:LATM1,1:NIVM1) = 0.0
	FCC1   (1:LONM1,1:LATM1,1:NIVM1) = 0.0
	FCCV1  (1:LONM1,1:LATM1,1:NIVM1) = 0.0
	QLIQ1  (1:LONM1,1:LATM1,1:NIVM1) = 0.0
	QICE1  (1:LONM1,1:LATM1,1:NIVM1) = 0.0
!$omp section
	PSOLM2 (1:LONM2,1:LATM2)         = 0.0
	XPAM2  (1:LONM2,1:LATM2,1:NIVM2) = 0.0
	XPHFM2 (1:LONM2,1:LATM2,1:NIVM2) = 0.0
	UGRIM2 (1:LONM2,1:LATM2,1:NIVM2) = 0.0
	VGRIM2 (1:LONM2,1:LATM2,1:NIVM2) = 0.0
	WGRIM2 (1:LONM2,1:LATM2,1:NIVM2) = 0.0
	TGRIM2 (1:LONM2,1:LATM2,1:NIVM2) = 0.0
	QGRIM2 (1:LONM2,1:LATM2,1:NIVM2) = 0.0
	PVGRIM2(1:LONM2,1:LATM2,1:NIVM2) = 0.0
	DIVQM2 (1:LONM2,1:LATM2,1:NIVM2) = 0.0
	DIVUM2 (1:LONM2,1:LATM2,1:NIVM2) = 0.0
	FCC2   (1:LONM2,1:LATM2,1:NIVM2) = 0.0
	FCCV2  (1:LONM2,1:LATM2,1:NIVM2) = 0.0
	QLIQ2  (1:LONM2,1:LATM2,1:NIVM2) = 0.0
	QICE2  (1:LONM2,1:LATM2,1:NIVM2) = 0.0
!$omp section
	PSOLM3 (1:LONM3,1:LATM3)         = 0.0
	XPAM3  (1:LONM3,1:LATM3,1:NIVM3) = 0.0
	XPHFM3 (1:LONM3,1:LATM3,1:NIVM3) = 0.0
	UGRIM3 (1:LONM3,1:LATM3,1:NIVM3) = 0.0
	VGRIM3 (1:LONM3,1:LATM3,1:NIVM3) = 0.0
	WGRIM3 (1:LONM3,1:LATM3,1:NIVM3) = 0.0
	TGRIM3 (1:LONM3,1:LATM3,1:NIVM3) = 0.0
	QGRIM3 (1:LONM3,1:LATM3,1:NIVM3) = 0.0
	PVGRIM3(1:LONM3,1:LATM3,1:NIVM3) = 0.0
	DIVQM3 (1:LONM3,1:LATM3,1:NIVM3) = 0.0
	DIVUM3 (1:LONM3,1:LATM3,1:NIVM3) = 0.0
	FCC3   (1:LONM3,1:LATM3,1:NIVM3) = 0.0
	FCCV3  (1:LONM3,1:LATM3,1:NIVM3) = 0.0
	QLIQ3  (1:LONM3,1:LATM3,1:NIVM3) = 0.0
	QICE3  (1:LONM3,1:LATM3,1:NIVM3) = 0.0
!$omp section
	PSOLM4 (1:LONM4,1:LATM4)         = 0.0
	XPAM4  (1:LONM4,1:LATM4,1:NIVM4) = 0.0
	XPHFM4 (1:LONM4,1:LATM4,1:NIVM4) = 0.0
	UGRIM4 (1:LONM4,1:LATM4,1:NIVM4) = 0.0
	VGRIM4 (1:LONM4,1:LATM4,1:NIVM4) = 0.0
	WGRIM4 (1:LONM4,1:LATM4,1:NIVM4) = 0.0
	TGRIM4 (1:LONM4,1:LATM4,1:NIVM4) = 0.0
	QGRIM4 (1:LONM4,1:LATM4,1:NIVM4) = 0.0
	PVGRIM4(1:LONM4,1:LATM4,1:NIVM4) = 0.0
	DIVQM4 (1:LONM4,1:LATM4,1:NIVM4) = 0.0
	DIVUM4 (1:LONM4,1:LATM4,1:NIVM4) = 0.0
	FCC4   (1:LONM4,1:LATM4,1:NIVM4) = 0.0
	FCCV4  (1:LONM4,1:LATM4,1:NIVM4) = 0.0
	QLIQ4  (1:LONM4,1:LATM4,1:NIVM4) = 0.0
	QICE4  (1:LONM4,1:LATM4,1:NIVM4) = 0.0
!$omp end parallel sections
!-- NEC

	END SUBROUTINE ALLOC_FORMT

	SUBROUTINE DEALLOC_FORMT

	DEALLOCATE (PSOLM1)
	DEALLOCATE (XPAM1)
	DEALLOCATE (XPHFM1)
	DEALLOCATE (UGRIM1)
	DEALLOCATE (VGRIM1)
	DEALLOCATE (WGRIM1)
	DEALLOCATE (TGRIM1)
	DEALLOCATE (QGRIM1)
	DEALLOCATE (PVGRIM1)
	DEALLOCATE (DIVQM1)
	DEALLOCATE (DIVUM1)
	DEALLOCATE (FCC1)
	DEALLOCATE (FCCV1)
	DEALLOCATE (QLIQ1)
	DEALLOCATE (QICE1)

	DEALLOCATE (PSOLM2)
	DEALLOCATE (XPAM2)
	DEALLOCATE (XPHFM2)
	DEALLOCATE (UGRIM2)
	DEALLOCATE (VGRIM2)
	DEALLOCATE (WGRIM2)
	DEALLOCATE (TGRIM2)
	DEALLOCATE (QGRIM2)
	DEALLOCATE (PVGRIM2)
	DEALLOCATE (DIVQM2)
	DEALLOCATE (DIVUM2)
	DEALLOCATE (FCC2)
	DEALLOCATE (FCCV2)
	DEALLOCATE (QLIQ2)
	DEALLOCATE (QICE2)

	DEALLOCATE (PSOLM3)
	DEALLOCATE (XPAM3)
	DEALLOCATE (XPHFM3)
	DEALLOCATE (UGRIM3)
	DEALLOCATE (VGRIM3)
	DEALLOCATE (WGRIM3)
	DEALLOCATE (TGRIM3)
	DEALLOCATE (QGRIM3)
	DEALLOCATE (PVGRIM3)
	DEALLOCATE (DIVQM3)
	DEALLOCATE (DIVUM3)
	DEALLOCATE (FCC3)
	DEALLOCATE (FCCV3)
	DEALLOCATE (QLIQ3)
	DEALLOCATE (QICE3)

	DEALLOCATE (PSOLM4)
	DEALLOCATE (XPAM4)
	DEALLOCATE (XPHFM4)
	DEALLOCATE (UGRIM4)
	DEALLOCATE (VGRIM4)
	DEALLOCATE (WGRIM4)
	DEALLOCATE (TGRIM4)
	DEALLOCATE (QGRIM4)
	DEALLOCATE (PVGRIM4)
	DEALLOCATE (DIVQM4)
	DEALLOCATE (DIVUM4)
	DEALLOCATE (FCC4)
	DEALLOCATE (FCCV4)
	DEALLOCATE (QLIQ4)
	DEALLOCATE (QICE4)

	END SUBROUTINE DEALLOC_FORMT

	END MODULE FORMT_MOD
