	MODULE HENRY_MOD
C
C------------------------------------------------------------------------
C 	SAME AS OLD COMMON/HENRY/
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	IMPLICIT NONE
C
C
	REAL (KIND=8) , ALLOCATABLE , SAVE :: XKHENRY1(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: XKHENRY2(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: XKHENRY3(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: XKHENRY4(:,:)
C
	CONTAINS
C
	SUBROUTINE ALLOC_HENRY
C
	USE PARADI_MOD
C
	ALLOCATE (XKHENRY1(NTRA1,2)) ; XKHENRY1(:,:) = 0.0
	ALLOCATE (XKHENRY2(NTRA2,2)) ; XKHENRY2(:,:) = 0.0
	ALLOCATE (XKHENRY3(NTRA3,2)) ; XKHENRY3(:,:) = 0.0
	ALLOCATE (XKHENRY4(NTRA4,2)) ; XKHENRY4(:,:) = 0.0
C
	END SUBROUTINE ALLOC_HENRY
C
	SUBROUTINE DEALLOC_HENRY
C
	DEALLOCATE (XKHENRY1)
	DEALLOCATE (XKHENRY2)
	DEALLOCATE (XKHENRY3)
	DEALLOCATE (XKHENRY4)
C
	END SUBROUTINE DEALLOC_HENRY
C
	END MODULE HENRY_MOD
