	MODULE MRAT_MOD
C
C------------------------------------------------------------------------
C 	DESCRITION AND DISTRIBUTIONS OF TRANSPORTED
C 	AND TRANSIENT SPECIES
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	USE PARADI_MOD
	USE EXPE_MOD
C
	IMPLICIT NONE
C
	CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: TRANAM1(:),SLSNAM1(:)
	CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: EMINAM1(:),DEPNAM1(:) 
	INTEGER , ALLOCATABLE , SAVE :: IQMEMI1(:),IQMDEP1(:),IHMDEP1(:)
	REAL (KIND=8), ALLOCATABLE , SAVE, TARGET :: QQQM1(:,:,:,:)
	REAL (KIND=8), ALLOCATABLE , SAVE, TARGET  :: HHHM1(:,:,:,:)

	CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: TRANAM2(:),SLSNAM2(:)
	CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: EMINAM2(:),DEPNAM2(:) 
	INTEGER , ALLOCATABLE , SAVE :: IQMEMI2(:),IQMDEP2(:),IHMDEP2(:)
	REAL (KIND=8), ALLOCATABLE , SAVE, TARGET :: QQQM2(:,:,:,:)
	REAL (KIND=8), ALLOCATABLE , SAVE, TARGET  :: HHHM2(:,:,:,:)
	
	CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: TRANAM3(:),SLSNAM3(:)
	CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: EMINAM3(:),DEPNAM3(:) 
	INTEGER , ALLOCATABLE , SAVE :: IQMEMI3(:),IQMDEP3(:),IHMDEP3(:)
	REAL (KIND=8), ALLOCATABLE , SAVE, TARGET :: QQQM3(:,:,:,:)
	REAL (KIND=8), ALLOCATABLE , SAVE, TARGET  :: HHHM3(:,:,:,:)
	
	CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: TRANAM4(:),SLSNAM4(:)
	CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: EMINAM4(:),DEPNAM4(:) 
	INTEGER , ALLOCATABLE , SAVE :: IQMEMI4(:),IQMDEP4(:),IHMDEP4(:)
	REAL (KIND=8), ALLOCATABLE , SAVE, TARGET :: QQQM4(:,:,:,:)
	REAL (KIND=8), ALLOCATABLE , SAVE, TARGET  :: HHHM4(:,:,:,:)
C
	INTEGER, ALLOCATABLE, SAVE :: iga_assim_idx(:)
	CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: cga_assim_sp(:)
C
	CONTAINS
C
	SUBROUTINE ALLOC_MRAT
C
	ALLOCATE (TRANAM1(NTRA1)) ; TRANAM1(:) = "123456789 12345"
	ALLOCATE (QQQM1(LONM1,LATM1,NIVM1,NTRA1)) ; QQQM1(:,:,:,:) = 0.0
	IF (NSLS1 .gt. 0) THEN
	    ALLOCATE (SLSNAM1(NSLS1)) ; SLSNAM1(:) = "123456789 12345"
	    ALLOCATE (HHHM1(LONM1,LATM1,NIVM1,NSLS1)) ; HHHM1(:,:,:,:) = 0.0
	ENDIF
C
	ALLOCATE (TRANAM2(NTRA2)) ; TRANAM2(:) = "123456789 12345"
	ALLOCATE (QQQM2(LONM2,LATM2,NIVM2,NTRA2)) ; QQQM2(:,:,:,:) = 0.0
	IF (NSLS2 .gt. 0) THEN
	    ALLOCATE (SLSNAM2(NSLS2)) ; SLSNAM2(:) = "123456789 12345"
	    ALLOCATE (HHHM2(LONM2,LATM2,NIVM2,NSLS2)) ; HHHM2(:,:,:,:) = 0.0
	ENDIF
C	
	ALLOCATE (TRANAM3(NTRA3)) ; TRANAM3(:) = "123456789 12345"
	ALLOCATE (QQQM3(LONM3,LATM3,NIVM3,NTRA3)) ; QQQM3(:,:,:,:) = 0.0
	IF (NSLS3 .gt. 0) THEN
	    ALLOCATE (SLSNAM3(NSLS3)) ; SLSNAM3(:) = "123456789 12345"
	    ALLOCATE (HHHM3(LONM3,LATM3,NIVM3,NSLS3)) ; HHHM3(:,:,:,:) = 0.0
	ENDIF
C
	ALLOCATE (TRANAM4(NTRA4)) ; TRANAM4(:) = "123456789 12345"
	ALLOCATE (QQQM4(LONM4,LATM4,NIVM4,NTRA4)) ; QQQM4(:,:,:,:) = 0.0
	IF (NSLS4 .gt. 0) THEN
	    ALLOCATE (SLSNAM4(NSLS4)) ; SLSNAM4(:) = "123456789 12345"
	    ALLOCATE (HHHM4(LONM4,LATM4,NIVM4,NSLS4)) ; HHHM4(:,:,:,:) = 0.0
	ENDIF
C
	IF ((ig_run_mode .eq. DRY_RUN .or.
     $       ig_run_mode .eq. DIR_MODEL) .and. SURF) THEN

            ALLOCATE (EMINAM1(NEMI1))	 ; EMINAM1(:) = "123456789 12345"
            ALLOCATE (DEPNAM1(NDEP1))	 ; DEPNAM1(:) = "123456789 12345"
            ALLOCATE (IQMEMI1(NTRA1))	 ; IQMEMI1(:) = 0
            ALLOCATE (IQMDEP1(NTRA1))	 ; IQMDEP1(:) = 0
            IF (NSLS1 .gt. 0) THEN
            ALLOCATE (IHMDEP1(NSLS1))	 ; IHMDEP1(:) = 0
            END IF

            ALLOCATE (EMINAM2(NEMI2))	 ; EMINAM2(:) = "123456789 12345"
            ALLOCATE (DEPNAM2(NDEP2))	 ; DEPNAM2(:) = "123456789 12345"
            ALLOCATE (IQMEMI2(NTRA2))	 ; IQMEMI2(:) = 0
            ALLOCATE (IQMDEP2(NTRA2))	 ; IQMDEP2(:) = 0
            IF (NSLS2 .gt. 0) THEN
            ALLOCATE (IHMDEP2(NSLS2))	 ; IHMDEP2(:) = 0
            END IF

            ALLOCATE (EMINAM3(NEMI3))	 ; EMINAM3(:) = "123456789 12345"
            ALLOCATE (DEPNAM3(NDEP3))	 ; DEPNAM3(:) = "123456789 12345"
            ALLOCATE (IQMEMI3(NTRA3))	 ; IQMEMI3(:) = 0
            ALLOCATE (IQMDEP3(NTRA3))	 ; IQMDEP3(:) = 0
            IF (NSLS3 .gt. 0) THEN
            ALLOCATE (IHMDEP3(NSLS3))	 ; IHMDEP3(:) = 0
            END IF

            ALLOCATE (EMINAM4(NEMI4))	 ; EMINAM4(:) = "123456789 12345"
            ALLOCATE (DEPNAM4(NDEP4))	 ; DEPNAM4(:) = "123456789 12345"
            ALLOCATE (IQMEMI4(NTRA4))	 ; IQMEMI4(:) = 0
            ALLOCATE (IQMDEP4(NTRA4))	 ; IQMDEP4(:) = 0
            IF (NSLS4 .gt. 0) THEN
            ALLOCATE (IHMDEP4(NSLS4))	 ; IHMDEP4(:) = 0
            END IF


	ENDIF
C
	IF (ig_run_mode .eq. DIR_MODEL .or.
     $      ig_run_mode .eq. OBS_OPERATOR) THEN
	    ALLOCATE (iga_assim_idx(NASSIM1)) ; iga_assim_idx(:) = 0
	    ALLOCATE (cga_assim_sp(NASSIM1)) ;  cga_assim_sp (:) = "123456789 12345"
	ENDIF
C
	END SUBROUTINE ALLOC_MRAT
C
	SUBROUTINE DEALLOC_MRAT
C
	DEALLOCATE (TRANAM1)
	DEALLOCATE (QQQM1)
	IF (NSLS1 .gt. 0) THEN
	    DEALLOCATE (SLSNAM1)
	    DEALLOCATE (HHHM1)
	ENDIF
C
	DEALLOCATE (TRANAM2)
	DEALLOCATE (QQQM2)
	IF (NSLS2 .gt. 0) THEN
	    DEALLOCATE (SLSNAM2)
	    DEALLOCATE (HHHM2)
	ENDIF
C	
	DEALLOCATE (TRANAM3)
	DEALLOCATE (QQQM3)
	IF (NSLS3 .gt. 0) THEN
	    DEALLOCATE (SLSNAM3)
	    DEALLOCATE (HHHM3)
	ENDIF
C
	DEALLOCATE (TRANAM4)
	DEALLOCATE (QQQM4)
	IF (NSLS4 .gt. 0) THEN
	    DEALLOCATE (SLSNAM4)
	    DEALLOCATE (HHHM4)
	ENDIF
C
	IF ((ig_run_mode .eq. DRY_RUN .or.
     $       ig_run_mode .eq. DIR_MODEL) .and. SURF) THEN
C
	    DEALLOCATE (EMINAM1)
	    DEALLOCATE (DEPNAM1)
	    DEALLOCATE (IQMEMI1)
	    DEALLOCATE (IQMDEP1)
	    IF (NSLS1 .gt. 0) DEALLOCATE (IHMDEP1)
C
	    DEALLOCATE (EMINAM2)
	    DEALLOCATE (DEPNAM2)
	    DEALLOCATE (IQMEMI2)
	    DEALLOCATE (IQMDEP2)
	    IF (NSLS2 .gt. 0) DEALLOCATE (IHMDEP2)
C
	    DEALLOCATE (EMINAM3)
	    DEALLOCATE (DEPNAM3)
	    DEALLOCATE (IQMEMI3)
	    DEALLOCATE (IQMDEP3)
	    IF (NSLS3 .gt. 0) DEALLOCATE (IHMDEP3)
C
	    DEALLOCATE (EMINAM4)
	    DEALLOCATE (DEPNAM4)
	    DEALLOCATE (IQMEMI4)
	    DEALLOCATE (IQMDEP4)
	    IF (NSLS4 .gt. 0) DEALLOCATE (IHMDEP4)
C
	ENDIF
C
	IF (ig_run_mode .eq. DIR_MODEL .or.
     $      ig_run_mode .eq. OBS_OPERATOR) THEN
	    DEALLOCATE (iga_assim_idx)
	    DEALLOCATE (cga_assim_sp)
	ENDIF
C
	END SUBROUTINE DEALLOC_MRAT
C
	END MODULE MRAT_MOD
