	MODULE TOPCH_MOD
C
C------------------------------------------------------------------------
C 	TOP BOUNDARY CONDITIONS
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	IMPLICIT NONE
C
C
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QQMCHF1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QQMCHF2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QQMCHF3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QQMCHF4(:,:,:)
C
	CONTAINS
C
	SUBROUTINE ALLOC_TOPCH
C
	USE PARADI_MOD
C
	ALLOCATE (QQMCHF1(LONM1,LATM1,NTRA1)) ; QQMCHF1(:,:,:) = 0.0
	ALLOCATE (QQMCHF2(LONM2,LATM2,NTRA2)) ; QQMCHF2(:,:,:) = 0.0
	ALLOCATE (QQMCHF3(LONM3,LATM3,NTRA3)) ; QQMCHF3(:,:,:) = 0.0
	ALLOCATE (QQMCHF4(LONM4,LATM4,NTRA4)) ; QQMCHF4(:,:,:) = 0.0
C
	END SUBROUTINE ALLOC_TOPCH
C
	SUBROUTINE DEALLOC_TOPCH
C
	DEALLOCATE (QQMCHF1)
	DEALLOCATE (QQMCHF2)
	DEALLOCATE (QQMCHF3)
	DEALLOCATE (QQMCHF4)
C
	END SUBROUTINE DEALLOC_TOPCH
C
	END MODULE TOPCH_MOD
