	MODULE FORC_MOD
C
C------------------------------------------------------------------------
C 	FORCINGS FOR CYCLE END AND BEGINNING (ON FORCINGS GRIDS)
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	IMPLICIT NONE
C
C
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DATEF1A(:),DATEF1B(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DATEF2A(:),DATEF2B(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DATEF3A(:),DATEF3B(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DATEF4A(:),DATEF4B(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOLF1A(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UGRIF1A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VGRIF1A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: WGRIF1A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TGRIF1A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIF1A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PVGRIF1A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOLF1B(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UGRIF1B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VGRIF1B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: WGRIF1B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TGRIF1B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIF1B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PVGRIF1B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOLF2A(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UGRIF2A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VGRIF2A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: WGRIF2A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TGRIF2A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIF2A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PVGRIF2A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOLF2B(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UGRIF2B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VGRIF2B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: WGRIF2B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TGRIF2B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIF2B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PVGRIF2B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOLF3A(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UGRIF3A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VGRIF3A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: WGRIF3A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TGRIF3A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIF3A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PVGRIF3A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOLF3B(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UGRIF3B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VGRIF3B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: WGRIF3B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TGRIF3B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIF3B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PVGRIF3B(:,:,:)	
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOLF4A(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UGRIF4A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VGRIF4A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: WGRIF4A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TGRIF4A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIF4A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PVGRIF4A(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOLF4B(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UGRIF4B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VGRIF4B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: WGRIF4B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TGRIF4B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIF4B(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PVGRIF4B(:,:,:)
C
	CONTAINS
C
	SUBROUTINE ALLOC_FORC
C
	USE PARADI_MOD
C
        ALLOCATE (DATEF1A(4))	 ; DATEF1A(:) = 0.0
        ALLOCATE (PSOLF1A(LONF1,LATF1))	 ; PSOLF1A(:,:) = 0.0
        ALLOCATE (UGRIF1A(LONF1,LATF1,NIVF1))	 ; UGRIF1A(:,:,:) = 0.0
        ALLOCATE (VGRIF1A(LONF1,LATF1,NIVF1))	 ; VGRIF1A(:,:,:) = 0.0
        ALLOCATE (WGRIF1A(LONF1,LATF1,NIVF1))	 ; WGRIF1A(:,:,:) = 0.0
        ALLOCATE (TGRIF1A(LONF1,LATF1,NIVF1))	 ; TGRIF1A(:,:,:) = 0.0
        ALLOCATE (QGRIF1A(LONF1,LATF1,NIVF1))	 ; QGRIF1A(:,:,:) = 0.0
        ALLOCATE (PVGRIF1A(LONF1,LATF1,NIVF1))	 ; PVGRIF1A(:,:,:) = 0.0
C       	C       
        ALLOCATE (DATEF1B(4))	 ; DATEF1B(:) = 0.0
        ALLOCATE (PSOLF1B(LONF1,LATF1))	 ; PSOLF1B(:,:) = 0.0
        ALLOCATE (UGRIF1B(LONF1,LATF1,NIVF1))	 ; UGRIF1B(:,:,:) = 0.0
        ALLOCATE (VGRIF1B(LONF1,LATF1,NIVF1))	 ; VGRIF1B(:,:,:) = 0.0
        ALLOCATE (WGRIF1B(LONF1,LATF1,NIVF1))	 ; WGRIF1B(:,:,:) = 0.0
        ALLOCATE (TGRIF1B(LONF1,LATF1,NIVF1))	 ; TGRIF1B(:,:,:) = 0.0
        ALLOCATE (QGRIF1B(LONF1,LATF1,NIVF1))	 ; QGRIF1B(:,:,:) = 0.0
        ALLOCATE (PVGRIF1B(LONF1,LATF1,NIVF1))   ; PVGRIF1B(:,:,:) = 0.0  
C	C
        ALLOCATE (DATEF2A(4))	 ; DATEF2A(:) = 0.0
        ALLOCATE (PSOLF2A(LONF2,LATF2))	 ; PSOLF2A(:,:) = 0.0
        ALLOCATE (UGRIF2A(LONF2,LATF2,NIVF2))	 ; UGRIF2A(:,:,:) = 0.0
        ALLOCATE (VGRIF2A(LONF2,LATF2,NIVF2))	 ; VGRIF2A(:,:,:) = 0.0
        ALLOCATE (WGRIF2A(LONF2,LATF2,NIVF2))	 ; WGRIF2A(:,:,:) = 0.0
        ALLOCATE (TGRIF2A(LONF2,LATF2,NIVF2))	 ; TGRIF2A(:,:,:) = 0.0
        ALLOCATE (QGRIF2A(LONF2,LATF2,NIVF2))	 ; QGRIF2A(:,:,:) = 0.0
        ALLOCATE (PVGRIF2A(LONF2,LATF2,NIVF2))	 ; PVGRIF2A(:,:,:) = 0.0
C       	C       
        ALLOCATE (DATEF2B(4))	 ; DATEF2B(:) = 0.0
        ALLOCATE (PSOLF2B(LONF2,LATF2))	 ; PSOLF2B(:,:) = 0.0
        ALLOCATE (UGRIF2B(LONF2,LATF2,NIVF2))	 ; UGRIF2B(:,:,:) = 0.0
        ALLOCATE (VGRIF2B(LONF2,LATF2,NIVF2))	 ; VGRIF2B(:,:,:) = 0.0
        ALLOCATE (WGRIF2B(LONF2,LATF2,NIVF2))	 ; WGRIF2B(:,:,:) = 0.0
        ALLOCATE (TGRIF2B(LONF2,LATF2,NIVF2))	 ; TGRIF2B(:,:,:) = 0.0
        ALLOCATE (QGRIF2B(LONF2,LATF2,NIVF2))	 ; QGRIF2B(:,:,:) = 0.0
        ALLOCATE (PVGRIF2B(LONF2,LATF2,NIVF2))   ; PVGRIF2B(:,:,:) = 0.0  
        	        
        ALLOCATE (DATEF3A(4))	 ; DATEF3A(:) = 0.0
        ALLOCATE (PSOLF3A(LONF3,LATF3))	 ; PSOLF3A(:,:) = 0.0
        ALLOCATE (UGRIF3A(LONF3,LATF3,NIVF3))	 ; UGRIF3A(:,:,:) = 0.0
        ALLOCATE (VGRIF3A(LONF3,LATF3,NIVF3))	 ; VGRIF3A(:,:,:) = 0.0
        ALLOCATE (WGRIF3A(LONF3,LATF3,NIVF3))	 ; WGRIF3A(:,:,:) = 0.0
        ALLOCATE (TGRIF3A(LONF3,LATF3,NIVF3))	 ; TGRIF3A(:,:,:) = 0.0
        ALLOCATE (QGRIF3A(LONF3,LATF3,NIVF3))	 ; QGRIF3A(:,:,:) = 0.0
        ALLOCATE (PVGRIF3A(LONF3,LATF3,NIVF3))	 ; PVGRIF3A(:,:,:) = 0.0
C       	C       
        ALLOCATE (DATEF3B(4))	 ; DATEF3B(:) = 0.0
        ALLOCATE (PSOLF3B(LONF3,LATF3))	 ; PSOLF3B(:,:) = 0.0
        ALLOCATE (UGRIF3B(LONF3,LATF3,NIVF3))	 ; UGRIF3B(:,:,:) = 0.0
        ALLOCATE (VGRIF3B(LONF3,LATF3,NIVF3))	 ; VGRIF3B(:,:,:) = 0.0
        ALLOCATE (WGRIF3B(LONF3,LATF3,NIVF3))	 ; WGRIF3B(:,:,:) = 0.0
        ALLOCATE (TGRIF3B(LONF3,LATF3,NIVF3))	 ; TGRIF3B(:,:,:) = 0.0
        ALLOCATE (QGRIF3B(LONF3,LATF3,NIVF3))	 ; QGRIF3B(:,:,:) = 0.0
        ALLOCATE (PVGRIF3B(LONF3,LATF3,NIVF3))   ; PVGRIF3B(:,:,:) = 0.0  
        	        
        ALLOCATE (DATEF4A(4))	 ; DATEF4A(:) = 0.0
        ALLOCATE (PSOLF4A(LONF4,LATF4))	 ; PSOLF4A(:,:) = 0.0
        ALLOCATE (UGRIF4A(LONF4,LATF4,NIVF4))	 ; UGRIF4A(:,:,:) = 0.0
        ALLOCATE (VGRIF4A(LONF4,LATF4,NIVF4))	 ; VGRIF4A(:,:,:) = 0.0
        ALLOCATE (WGRIF4A(LONF4,LATF4,NIVF4))	 ; WGRIF4A(:,:,:) = 0.0
        ALLOCATE (TGRIF4A(LONF4,LATF4,NIVF4))	 ; TGRIF4A(:,:,:) = 0.0
        ALLOCATE (QGRIF4A(LONF4,LATF4,NIVF4))	 ; QGRIF4A(:,:,:) = 0.0
        ALLOCATE (PVGRIF4A(LONF4,LATF4,NIVF4))	 ; PVGRIF4A(:,:,:) = 0.0
C       	C       
        ALLOCATE (DATEF4B(4))	 ; DATEF4B(:) = 0.0
        ALLOCATE (PSOLF4B(LONF4,LATF4))	 ; PSOLF4B(:,:) = 0.0
        ALLOCATE (UGRIF4B(LONF4,LATF4,NIVF4))	 ; UGRIF4B(:,:,:) = 0.0
        ALLOCATE (VGRIF4B(LONF4,LATF4,NIVF4))	 ; VGRIF4B(:,:,:) = 0.0
        ALLOCATE (WGRIF4B(LONF4,LATF4,NIVF4))	 ; WGRIF4B(:,:,:) = 0.0
        ALLOCATE (TGRIF4B(LONF4,LATF4,NIVF4))	 ; TGRIF4B(:,:,:) = 0.0
        ALLOCATE (QGRIF4B(LONF4,LATF4,NIVF4))	 ; QGRIF4B(:,:,:) = 0.0
        ALLOCATE (PVGRIF4B(LONF4,LATF4,NIVF4))   ; PVGRIF4B(:,:,:) = 0.0  
C
	END SUBROUTINE ALLOC_FORC
C
	SUBROUTINE DEALLOC_FORC
C
	DEALLOCATE (DATEF1A)
	DEALLOCATE (PSOLF1A)
	DEALLOCATE (UGRIF1A)
	DEALLOCATE (VGRIF1A)
	DEALLOCATE (WGRIF1A)
	DEALLOCATE (TGRIF1A)
	DEALLOCATE (QGRIF1A)
	DEALLOCATE (PVGRIF1A)
C	
	DEALLOCATE (DATEF1B)
	DEALLOCATE (PSOLF1B)
	DEALLOCATE (UGRIF1B)
	DEALLOCATE (VGRIF1B)
	DEALLOCATE (WGRIF1B)
	DEALLOCATE (TGRIF1B)
	DEALLOCATE (QGRIF1B)
	DEALLOCATE (PVGRIF1B)
C
	DEALLOCATE (DATEF2A)
	DEALLOCATE (PSOLF2A)
	DEALLOCATE (UGRIF2A)
	DEALLOCATE (VGRIF2A)
	DEALLOCATE (WGRIF2A)
	DEALLOCATE (TGRIF2A)
	DEALLOCATE (QGRIF2A)
	DEALLOCATE (PVGRIF2A)
C	
	DEALLOCATE (DATEF2B)
	DEALLOCATE (PSOLF2B)
	DEALLOCATE (UGRIF2B)
	DEALLOCATE (VGRIF2B)
	DEALLOCATE (WGRIF2B)
	DEALLOCATE (TGRIF2B)
	DEALLOCATE (QGRIF2B)
	DEALLOCATE (PVGRIF2B)
	
	DEALLOCATE (DATEF3A)
	DEALLOCATE (PSOLF3A)
	DEALLOCATE (UGRIF3A)
	DEALLOCATE (VGRIF3A)
	DEALLOCATE (WGRIF3A)
	DEALLOCATE (TGRIF3A)
	DEALLOCATE (QGRIF3A)
	DEALLOCATE (PVGRIF3A)
C	
	DEALLOCATE (DATEF3B)
	DEALLOCATE (PSOLF3B)
	DEALLOCATE (UGRIF3B)
	DEALLOCATE (VGRIF3B)
	DEALLOCATE (WGRIF3B)
	DEALLOCATE (TGRIF3B)
	DEALLOCATE (QGRIF3B)
	DEALLOCATE (PVGRIF3B)
	
	DEALLOCATE (DATEF4A)
	DEALLOCATE (PSOLF4A)
	DEALLOCATE (UGRIF4A)
	DEALLOCATE (VGRIF4A)
	DEALLOCATE (WGRIF4A)
	DEALLOCATE (TGRIF4A)
	DEALLOCATE (QGRIF4A)
	DEALLOCATE (PVGRIF4A)
C	
	DEALLOCATE (DATEF4B)
	DEALLOCATE (PSOLF4B)
	DEALLOCATE (UGRIF4B)
	DEALLOCATE (VGRIF4B)
	DEALLOCATE (WGRIF4B)
	DEALLOCATE (TGRIF4B)
	DEALLOCATE (QGRIF4B)
	DEALLOCATE (PVGRIF4B)	
C
	END SUBROUTINE DEALLOC_FORC
C
	END MODULE FORC_MOD
