	MODULE FORFT_MOD
C
C------------------------------------------------------------------------
C 	forcage a l'instant t (sur les grilles du forcage)
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	IMPLICIT NONE
C
C
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOLF1(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UGRIF1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VGRIF1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: WGRIF1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TGRIF1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIF1(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UMODF1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VMODF1(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOLF2(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UGRIF2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VGRIF2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: WGRIF2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TGRIF2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIF2(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UMODF2(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VMODF2(:,:,:)	
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOLF3(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UGRIF3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VGRIF3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: WGRIF3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TGRIF3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIF3(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UMODF3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VMODF3(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOLF4(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UGRIF4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VGRIF4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: WGRIF4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TGRIF4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QGRIF4(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UMODF4(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VMODF4(:,:,:)
C
	CONTAINS
C
	SUBROUTINE ALLOC_FORFT
C
	USE PARADI_MOD
C
        ALLOCATE (PSOLF1(LONF1,LATF1))	 ; PSOLF1(:,:) = 0.0
        ALLOCATE (UGRIF1(LONF1,LATF1,NIVF1))	 ; UGRIF1(:,:,:) = 0.0
        ALLOCATE (VGRIF1(LONF1,LATF1,NIVF1))	 ; VGRIF1(:,:,:) = 0.0
        ALLOCATE (WGRIF1(LONF1,LATF1,NIVF1))	 ; WGRIF1(:,:,:) = 0.0
        ALLOCATE (TGRIF1(LONF1,LATF1,NIVF1))	 ; TGRIF1(:,:,:) = 0.0
        ALLOCATE (UMODF1(LONF1,LATF1,NIVF1))	 ; UMODF1(:,:,:) = 0.0
        ALLOCATE (VMODF1(LONF1,LATF1,NIVF1))	 ; VMODF1(:,:,:) = 0.0

        ALLOCATE (PSOLF2(LONF2,LATF2))	 ; PSOLF2(:,:) = 0.0
        ALLOCATE (UGRIF2(LONF2,LATF2,NIVF2))	 ; UGRIF2(:,:,:) = 0.0
        ALLOCATE (VGRIF2(LONF2,LATF2,NIVF2))	 ; VGRIF2(:,:,:) = 0.0
        ALLOCATE (WGRIF2(LONF2,LATF2,NIVF2))	 ; WGRIF2(:,:,:) = 0.0
        ALLOCATE (TGRIF2(LONF2,LATF2,NIVF2))	 ; TGRIF2(:,:,:) = 0.0
        ALLOCATE (UMODF2(LONF2,LATF2,NIVF2))	 ; UMODF2(:,:,:) = 0.0
        ALLOCATE (VMODF2(LONF2,LATF2,NIVF2))    	 ; VMODF2(:,:,:) = 0.0    

        ALLOCATE (PSOLF3(LONF3,LATF3))	 ; PSOLF3(:,:) = 0.0
        ALLOCATE (UGRIF3(LONF3,LATF3,NIVF3))	 ; UGRIF3(:,:,:) = 0.0
        ALLOCATE (VGRIF3(LONF3,LATF3,NIVF3))	 ; VGRIF3(:,:,:) = 0.0
        ALLOCATE (WGRIF3(LONF3,LATF3,NIVF3))	 ; WGRIF3(:,:,:) = 0.0
        ALLOCATE (TGRIF3(LONF3,LATF3,NIVF3))	 ; TGRIF3(:,:,:) = 0.0
        ALLOCATE (UMODF3(LONF3,LATF3,NIVF3))	 ; UMODF3(:,:,:) = 0.0
        ALLOCATE (VMODF3(LONF3,LATF3,NIVF3))	 ; VMODF3(:,:,:) = 0.0

        ALLOCATE (PSOLF4(LONF4,LATF4))	 ; PSOLF4(:,:) = 0.0
        ALLOCATE (UGRIF4(LONF4,LATF4,NIVF4))	 ; UGRIF4(:,:,:) = 0.0
        ALLOCATE (VGRIF4(LONF4,LATF4,NIVF4))	 ; VGRIF4(:,:,:) = 0.0
        ALLOCATE (WGRIF4(LONF4,LATF4,NIVF4))	 ; WGRIF4(:,:,:) = 0.0
        ALLOCATE (TGRIF4(LONF4,LATF4,NIVF4))	 ; TGRIF4(:,:,:) = 0.0
        ALLOCATE (UMODF4(LONF4,LATF4,NIVF4))	 ; UMODF4(:,:,:) = 0.0
        ALLOCATE (VMODF4(LONF4,LATF4,NIVF4))	 ; VMODF4(:,:,:) = 0.0
C
	END SUBROUTINE ALLOC_FORFT
C
	SUBROUTINE DEALLOC_FORFT
C
	DEALLOCATE (PSOLF1)
	DEALLOCATE (UGRIF1)
	DEALLOCATE (VGRIF1)
	DEALLOCATE (WGRIF1)
	DEALLOCATE (TGRIF1)
	DEALLOCATE (UMODF1)
	DEALLOCATE (VMODF1)
C	
	DEALLOCATE (PSOLF2)
	DEALLOCATE (UGRIF2)
	DEALLOCATE (VGRIF2)
	DEALLOCATE (WGRIF2)
	DEALLOCATE (TGRIF2)
	DEALLOCATE (UMODF2)
	DEALLOCATE (VMODF2)	
C
	DEALLOCATE (PSOLF3)
	DEALLOCATE (UGRIF3)
	DEALLOCATE (VGRIF3)
	DEALLOCATE (WGRIF3)
	DEALLOCATE (TGRIF3)
	DEALLOCATE (UMODF3)
	DEALLOCATE (VMODF3)
C
	DEALLOCATE (PSOLF4)
	DEALLOCATE (UGRIF4)
	DEALLOCATE (VGRIF4)
	DEALLOCATE (WGRIF4)
	DEALLOCATE (TGRIF4)
	DEALLOCATE (UMODF4)
	DEALLOCATE (VMODF4)
C
	END SUBROUTINE DEALLOC_FORFT
C
	END MODULE FORFT_MOD   
