	MODULE GAUSS_MOD
C
C------------------------------------------------------------------------
C       LATITUDES FOR GAUSSIAN GRID
C
C	AUTHOR	: H.TEYSSEDRE B.JOSSE	- CNRM -
C	DATE		: 13/03/2006
C	VERSION	: 2_0_1
C------------------------------------------------------------------------
C
	IMPLICIT NONE
C
C
	REAL (KIND=8) , ALLOCATABLE , SAVE :: XLAT(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: YCOEF(:,:)
C
	CONTAINS
C
	SUBROUTINE ALLOC_GAUSS
C
	USE PARADI_MOD
C
	ALLOCATE (XLAT(-1:LATM1+2)) ; XLAT(:) =0.0
	ALLOCATE (YCOEF(0:LATM1,4)) ; YCOEF(:,:) =0.0
C
	END SUBROUTINE ALLOC_GAUSS
C
	SUBROUTINE DEALLOC_GAUSS
C
	DEALLOCATE (XLAT)
	DEALLOCATE (YCOEF)

	END SUBROUTINE DEALLOC_GAUSS
C
	END MODULE GAUSS_MOD
