	MODULE GRIDS_MOD
C
C------------------------------------------------------------------------
C 	DEFINITION FOR MODEL AND FORCING GRIDS
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	IMPLICIT NONE
C
C
	REAL (KIND=8) , SAVE :: RLONM1MIN,RLONM1MAX,DRLONM1
	REAL (KIND=8) , SAVE :: RLATM1MIN,RLATM1MAX,DRLATM1
	REAL (KIND=8) , ALLOCATABLE , SAVE :: RLONM1(:),RLATM1(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DLATM1(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SURFM1(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: ALM1(:),BLM1(:)
C	
	REAL (KIND=8) , SAVE :: RLONM2MIN,RLONM2MAX,DRLONM2
	REAL (KIND=8) , SAVE :: RLATM2MIN,RLATM2MAX,DRLATM2
	REAL (KIND=8) , ALLOCATABLE , SAVE :: RLONM2(:),RLATM2(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DLATM2(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SURFM2(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: ALM2(:),BLM2(:)
C
	REAL (KIND=8) , SAVE :: RLONM3MIN,RLONM3MAX,DRLONM3
	REAL (KIND=8) , SAVE :: RLATM3MIN,RLATM3MAX,DRLATM3
	REAL (KIND=8) , ALLOCATABLE , SAVE :: RLONM3(:),RLATM3(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DLATM3(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SURFM3(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: ALM3(:),BLM3(:)
C	
	REAL (KIND=8) , SAVE :: RLONM4MIN,RLONM4MAX,DRLONM4
	REAL (KIND=8) , SAVE :: RLATM4MIN,RLATM4MAX,DRLATM4
	REAL (KIND=8) , ALLOCATABLE , SAVE :: RLONM4(:),RLATM4(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DLATM4(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SURFM4(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: ALM4(:),BLM4(:)
C	
	REAL (KIND=8) , SAVE :: RLONF1MIN,RLONF1MAX,DRLONF1
	REAL (KIND=8) , SAVE :: RLATF1MIN,RLATF1MAX,DRLATF1
	REAL (KIND=8) , ALLOCATABLE , SAVE :: RLONF1(:),RLATF1(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLON1(:),CLON1(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLAT1(:),CLAT1(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLON1R(:,:),CLON1R(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLAT1R(:,:),CLAT1R(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: ALF1(:),BLF1(:)
	
	REAL (KIND=8) , SAVE :: RLONF2MIN,RLONF2MAX,DRLONF2
	REAL (KIND=8) , SAVE :: RLATF2MIN,RLATF2MAX,DRLATF2
	REAL (KIND=8) , ALLOCATABLE , SAVE :: RLONF2(:),RLATF2(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLON2(:),CLON2(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLAT2(:),CLAT2(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLON2R(:,:),CLON2R(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLAT2R(:,:),CLAT2R(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: ALF2(:),BLF2(:)
C	
	REAL (KIND=8) , SAVE :: RLONF3MIN,RLONF3MAX,DRLONF3
	REAL (KIND=8) , SAVE :: RLATF3MIN,RLATF3MAX,DRLATF3
	REAL (KIND=8) , ALLOCATABLE , SAVE :: RLONF3(:),RLATF3(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLON3(:),CLON3(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLAT3(:),CLAT3(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLON3R(:,:),CLON3R(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLAT3R(:,:),CLAT3R(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: ALF3(:),BLF3(:)
C	
	REAL (KIND=8) , SAVE :: RLONF4MIN,RLONF4MAX,DRLONF4
	REAL (KIND=8) , SAVE :: RLATF4MIN,RLATF4MAX,DRLATF4
	REAL (KIND=8) , ALLOCATABLE , SAVE :: RLONF4(:),RLATF4(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLON4(:),CLON4(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLAT4(:),CLAT4(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLON4R(:,:),CLON4R(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: SLAT4R(:,:),CLAT4R(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: ALF4(:),BLF4(:)    
C	
	LOGICAL , SAVE :: LGRID12,LGRID23,LGRID34
	INTEGER , ALLOCATABLE , SAVE :: IX12(:),IY12(:)
	INTEGER , ALLOCATABLE , SAVE :: IGRID12(:,:)
	INTEGER , ALLOCATABLE , SAVE :: IX23(:),IY23(:)
	INTEGER , ALLOCATABLE , SAVE :: IGRID23(:,:)
	INTEGER , ALLOCATABLE , SAVE :: IX34(:),IY34(:)
	INTEGER , ALLOCATABLE , SAVE :: IGRID34(:,:)

        INTEGER , SAVE :: KCVDEB1,KCVFIN1
        INTEGER , SAVE :: KCVDEB2,KCVFIN2
        INTEGER , SAVE :: KCVDEB3,KCVFIN3
        INTEGER , SAVE :: KCVDEB4,KCVFIN4

C
	CONTAINS
c
	SUBROUTINE ALLOC_GRIDS
C
	USE PARADI_MOD
C
	ALLOCATE (RLONM1(LONM1)) ; RLONM1(:) = 0.0
	ALLOCATE (RLATM1(LATM1)) ; RLATM1(:) = 0.0
	ALLOCATE (DLATM1(LATM1+1)) ; DLATM1(:) = 0.0
	ALLOCATE (SURFM1(LONM1,LATM1)) ; SURFM1(:,:) = 0.0
	ALLOCATE (ALM1(0:NIVM1)) ; ALM1(:) = 0.0
	ALLOCATE (BLM1(0:NIVM1)) ; BLM1(:) = 0.0
	ALLOCATE (RLONF1(LONF1)) ; RLONF1(:) = 0.0
	ALLOCATE (RLATF1(LATF1)) ; RLATF1(:) = 0.0
	ALLOCATE (SLON1(LONF1)) ; SLON1(:) = 0.0
	ALLOCATE (CLON1(LONF1)) ; CLON1(:) = 0.0
	ALLOCATE (SLAT1(LATF1)) ; SLAT1(:) = 0.0
	ALLOCATE (CLAT1(LATF1)) ; CLAT1(:) = 0.0
	ALLOCATE (SLON1R(LONF1,LATF1)) ; SLON1R(:,:) = 0.0
	ALLOCATE (CLON1R(LONF1,LATF1)) ; CLON1R(:,:) = 0.0
	ALLOCATE (SLAT1R(LONF1,LATF1)) ; SLAT1R(:,:) = 0.0
	ALLOCATE (CLAT1R(LONF1,LATF1)) ; CLAT1R(:,:) = 0.0
	ALLOCATE (ALF1(0:NIVF1)) ; ALF1(:) = 0.0
	ALLOCATE (BLF1(0:NIVF1)) ; BLF1(:) = 0.0
C
	ALLOCATE (RLONM2(LONM2)) ; RLONM2(:) = 0.0
	ALLOCATE (RLATM2(LATM2)) ; RLATM2(:) = 0.0
	ALLOCATE (DLATM2(LATM2+1)) ; DLATM2(:) = 0.0
	ALLOCATE (SURFM2(LONM2,LATM2)) ; SURFM2(:,:) = 0.0
	ALLOCATE (ALM2(0:NIVM2)) ; ALM2(:) = 0.0
	ALLOCATE (BLM2(0:NIVM2)) ; BLM2(:) = 0.0
	ALLOCATE (RLONF2(LONF2)) ; RLONF2(:) = 0.0
	ALLOCATE (RLATF2(LATF2)) ; RLATF2(:) = 0.0
	ALLOCATE (SLON2(LONF2)) ; SLON2(:) = 0.0
	ALLOCATE (CLON2(LONF2)) ; CLON2(:) = 0.0
	ALLOCATE (SLAT2(LATF2)) ; SLAT2(:) = 0.0
	ALLOCATE (CLAT2(LATF2)) ; CLAT2(:) = 0.0
	ALLOCATE (SLON2R(LONF2,LATF2)) ; SLON2R(:,:) = 0.0
	ALLOCATE (CLON2R(LONF2,LATF2)) ; CLON2R(:,:) = 0.0
	ALLOCATE (SLAT2R(LONF2,LATF2)) ; SLAT2R(:,:) = 0.0
	ALLOCATE (CLAT2R(LONF2,LATF2)) ; CLAT2R(:,:) = 0.0
	ALLOCATE (ALF2(0:NIVF2)) ; ALF2(:) = 0.0
	ALLOCATE (BLF2(0:NIVF2)) ; BLF2(:) = 0.0
C
	ALLOCATE (RLONM3(LONM3)) ; RLONM3(:) = 0.0
	ALLOCATE (RLATM3(LATM3)) ; RLATM3(:) = 0.0
	ALLOCATE (DLATM3(LATM3+1)) ; DLATM3(:) = 0.0
	ALLOCATE (SURFM3(LONM3,LATM3)) ; SURFM3(:,:) = 0.0
	ALLOCATE (ALM3(0:NIVM3)) ; ALM3(:) = 0.0
	ALLOCATE (BLM3(0:NIVM3)) ; BLM3(:) = 0.0
	ALLOCATE (RLONF3(LONF3)) ; RLONF3(:) = 0.0
	ALLOCATE (RLATF3(LATF3)) ; RLATF3(:) = 0.0
	ALLOCATE (SLON3(LONF3)) ; SLON3(:) = 0.0
	ALLOCATE (CLON3(LONF3)) ; CLON3(:) = 0.0
	ALLOCATE (SLAT3(LATF3)) ; SLAT3(:) = 0.0
	ALLOCATE (CLAT3(LATF3)) ; CLAT3(:) = 0.0
	ALLOCATE (SLON3R(LONF3,LATF3)) ; SLON3R(:,:) = 0.0
	ALLOCATE (CLON3R(LONF3,LATF3)) ; CLON3R(:,:) = 0.0
	ALLOCATE (SLAT3R(LONF3,LATF3)) ; SLAT3R(:,:) = 0.0
	ALLOCATE (CLAT3R(LONF3,LATF3)) ; CLAT3R(:,:) = 0.0
	ALLOCATE (ALF3(0:NIVF3)) ; ALF3(:) = 0.0
	ALLOCATE (BLF3(0:NIVF3)) ; BLF3(:) = 0.0
C	
	ALLOCATE (RLONM4(LONM4)) ; RLONM4(:) = 0.0
	ALLOCATE (RLATM4(LATM4)) ; RLATM4(:) = 0.0
	ALLOCATE (DLATM4(LATM4+1)) ; DLATM4(:) = 0.0
	ALLOCATE (SURFM4(LONM4,LATM4)) ; SURFM4(:,:) = 0.0
	ALLOCATE (ALM4(0:NIVM4)) ; ALM4(:) = 0.0
	ALLOCATE (BLM4(0:NIVM4)) ; BLM4(:) = 0.0
	ALLOCATE (RLONF4(LONF4)) ; RLONF4(:) = 0.0
	ALLOCATE (RLATF4(LATF4)) ; RLATF4(:) = 0.0
	ALLOCATE (SLON4(LONF4)) ; SLON4(:) = 0.0
	ALLOCATE (CLON4(LONF4)) ; CLON4(:) = 0.0
	ALLOCATE (SLAT4(LATF4)) ; SLAT4(:) = 0.0
	ALLOCATE (CLAT4(LATF4)) ; CLAT4(:) = 0.0
	ALLOCATE (SLON4R(LONF4,LATF4)) ; SLON4R(:,:) = 0.0
	ALLOCATE (CLON4R(LONF4,LATF4)) ; CLON4R(:,:) = 0.0
	ALLOCATE (SLAT4R(LONF4,LATF4)) ; SLAT4R(:,:) = 0.0
	ALLOCATE (CLAT4R(LONF4,LATF4)) ; CLAT4R(:,:) = 0.0
	ALLOCATE (ALF4(0:NIVF4)) ; ALF4(:) = 0.0
	ALLOCATE (BLF4(0:NIVF4)) ; BLF4(:) = 0.0
C	
	ALLOCATE (IX12(LONM1)) ; IX12(:) = 0
	ALLOCATE (IY12(LATM1)) ; IY12(:) = 0
	ALLOCATE (IGRID12(LONM1,LATM1)) ; IGRID12(:,:) = 0
	ALLOCATE (IX23(LONM2)) ; IX23(:) = 0
	ALLOCATE (IY23(LATM2)) ; IY23(:) = 0
	ALLOCATE (IGRID23(LONM2,LATM2)) ; IGRID23(:,:) = 0
	ALLOCATE (IX34(LONM3)) ; IX34(:) = 0
	ALLOCATE (IY34(LATM3)) ; IY34(:) = 0
	ALLOCATE (IGRID34(LONM3,LATM3)) ; IGRID34(:,:) = 0
C
	END SUBROUTINE ALLOC_GRIDS
C
	SUBROUTINE DEALLOC_GRIDS
C
	DEALLOCATE (RLONM1)
	DEALLOCATE (RLATM1)
	DEALLOCATE (DLATM1)
	DEALLOCATE (SURFM1)
	DEALLOCATE (ALM1)
	DEALLOCATE (BLM1)
	DEALLOCATE (RLONF1)
	DEALLOCATE (RLATF1)
	DEALLOCATE (SLON1)
	DEALLOCATE (CLON1)
	DEALLOCATE (SLAT1)
	DEALLOCATE (CLAT1)
	DEALLOCATE (SLON1R)
	DEALLOCATE (CLON1R)
	DEALLOCATE (SLAT1R)
	DEALLOCATE (CLAT1R)
	DEALLOCATE (ALF1)
	DEALLOCATE (BLF1)
C
	DEALLOCATE (RLONM2)
	DEALLOCATE (RLATM2)
	DEALLOCATE (DLATM2)
	DEALLOCATE (SURFM2)
	DEALLOCATE (ALM2)
	DEALLOCATE (BLM2)
	DEALLOCATE (RLONF2)
	DEALLOCATE (RLATF2)
	DEALLOCATE (SLON2)
	DEALLOCATE (CLON2)
	DEALLOCATE (SLAT2)
	DEALLOCATE (CLAT2)
	DEALLOCATE (SLON2R)
	DEALLOCATE (CLON2R)
	DEALLOCATE (SLAT2R)
	DEALLOCATE (CLAT2R)
	DEALLOCATE (ALF2)
	DEALLOCATE (BLF2)
C
	DEALLOCATE (RLONM3)
	DEALLOCATE (RLATM3)
	DEALLOCATE (DLATM3)
	DEALLOCATE (SURFM3)
	DEALLOCATE (ALM3)
	DEALLOCATE (BLM3)
	DEALLOCATE (RLONF3)
	DEALLOCATE (RLATF3)
	DEALLOCATE (SLON3)
	DEALLOCATE (CLON3)
	DEALLOCATE (SLAT3)
	DEALLOCATE (CLAT3)
	DEALLOCATE (SLON3R)
	DEALLOCATE (CLON3R)
	DEALLOCATE (SLAT3R)
	DEALLOCATE (CLAT3R)
	DEALLOCATE (ALF3)
	DEALLOCATE (BLF3)
C	
	DEALLOCATE (RLONM4)
	DEALLOCATE (RLATM4)
	DEALLOCATE (DLATM4)
	DEALLOCATE (SURFM4)
	DEALLOCATE (ALM4)
	DEALLOCATE (BLM4)
	DEALLOCATE (RLONF4)
	DEALLOCATE (RLATF4)
	DEALLOCATE (SLON4)
	DEALLOCATE (CLON4)
	DEALLOCATE (SLAT4)
	DEALLOCATE (CLAT4)
	DEALLOCATE (SLON4R)
	DEALLOCATE (CLON4R)
	DEALLOCATE (SLAT4R)
	DEALLOCATE (CLAT4R)
	DEALLOCATE (ALF4)
	DEALLOCATE (BLF4)
C	
	DEALLOCATE (IX12)
	DEALLOCATE (IY12)
	DEALLOCATE (IGRID12)
	DEALLOCATE (IX23)
	DEALLOCATE (IY23)
	DEALLOCATE (IGRID23)
	DEALLOCATE (IX34)
	DEALLOCATE (IY34)
	DEALLOCATE (IGRID34)
C
	END SUBROUTINE DEALLOC_GRIDS
C
	END MODULE GRIDS_MOD
