       SUBROUTINE MINIMPARIS(LON,LAT,NEMI,NHOUR,RLON,RLAT,EMINAM,EM)
C
C Subroutine visant  rduire les missions
C dans la rgion parisienne (pour le cas de l'inventaire EMEP)
C  S'applique au domaine EMEP05
C
C
       USE CSTES_MOD

       IMPLICIT NONE
C
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
       INTEGER :: LON,LAT,NEMI,NHOUR
       REAL (KIND=8) , DIMENSION(LON) :: RLON
       REAL (KIND=8) , DIMENSION(LAT) :: RLAT
       CHARACTER(LEN=15) , DIMENSION(NEMI) :: EMINAM
       REAL (KIND=8) , DIMENSION(LON,LAT,NEMI,0:NHOUR) :: EM
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
       INTEGER :: ILON,ILAT,IHOUR,IEMI
       INTEGER :: LONDEB,LATDEB,LONFIN,LATFIN
       REAL (KIND=8) :: RLONDEB,RLATDEB,RLONFIN,RLATFIN
       REAL (KIND=8) :: COEF
C
C
       COEF=0.8
C
C Paris se trouve a 4852' en lat et 220' en lon
C cad 48.86 et 2.33 en decimal
C on minimise les missions sur la maille contenant Paris et
C celles  lat+1 et lat-1, lon+1 et lon-1 (soit 
C 9 mailles en tout) 
C       
      RLATDEB=48.3 /CONV
      RLATFIN=49.2/CONV
      RLONDEB=2.3  /CONV
      RLONFIN=3.2 /CONV
C
       DO ILON=1,LON
        IF (RLON(ILON).LE.RLONDEB) THEN
         LONDEB=ILON
        ENDIF
       ENDDO 
        DO ILON=LON,1,-1
        IF (RLON(ILON).GE.RLONFIN) THEN
         LONFIN=ILON
        ENDIF
       ENDDO 
       DO ILAT=1,LAT
        IF (RLAT(ILAT).LE.RLATDEB) THEN
         LATDEB=ILAT
        ENDIF
       ENDDO 
        DO ILAT=LAT,1,-1
        IF (RLAT(ILAT).GE.RLATFIN) THEN
         LATFIN=ILAT
        ENDIF
       ENDDO 
C
       DO IEMI=1,NEMI
C       
        IF ( ( EMINAM(IEMI) .NE. 'ISO' ) .AND.
     +       ( EMINAM(IEMI) .NE. 'ALPI') .AND.
     +       ( EMINAM(IEMI) .NE. 'LIM' ) ) THEN
C             
         DO ILAT=LATDEB,LATFIN
          DO ILON=LONDEB,LONFIN
!cdir shortloop
           DO IHOUR=1,NHOUR
            EM(ILON,ILAT,IEMI,IHOUR)=COEF*EM(ILON,ILAT,IEMI,IHOUR)
           ENDDO
          ENDDO
         ENDDO

        ENDIF
       ENDDO
C
C
       RETURN
       END
