        MODULE PHOTO_MOD

!------------------------------------------------------------------------
! 	PHOTOLYSES
!
!	AUTHOR	: HERVE LE BERRE	- CERFACS -
!	DATE		: 03/08/2005
!	VERSION	: 1_0_0
!------------------------------------------------------------------------

        IMPLICIT NONE

        INTEGER , SAVE :: iphotNO,iphotCO2,iJO1D,iJNO2
        INTEGER , SAVE :: iINDUV,iINDUVCS,iUVB,iUVA
	REAL (KIND=8) , ALLOCATABLE , SAVE :: ajl(:,:,:,:,:)

#ifdef CARIOLLE
#define CPP_NPHOT 1
#endif
#ifdef REPROBUS
#define CPP_NPHOT 39
#endif
#ifdef RELACS
#define CPP_NPHOT 45
#endif
#ifdef RACMOBUS
#define CPP_NPHOT 55
#endif
#ifdef ACCIDENT
#define CPP_NPHOT 1
#endif
        integer, parameter :: nphotmaster=115
        integer, parameter :: nphot=CPP_NPHOT
        integer, parameter :: nz=41
        integer, parameter :: nalb=4
        integer, parameter :: nsza=18
        integer, parameter :: nozo=7

        CONTAINS

        SUBROUTINE ALLOC_PHOTO
          ALLOCATE (ajl(nphot,nz,nalb,nsza,nozo)) ; ajl(:,:,:,:,:) = 0.0
        END SUBROUTINE ALLOC_PHOTO

        SUBROUTINE DEALLOC_PHOTO
          DEALLOCATE (ajl)
        END SUBROUTINE DEALLOC_PHOTO 

        END MODULE PHOTO_MOD
