	MODULE POSI_MOD
C
C------------------------------------------------------------------------
C 	position des points origines
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	USE PARADI_MOD
C
	IMPLICIT NONE
C
C
	REAL (KIND=8) , ALLOCATABLE , TARGET , SAVE :: 
     $                              X1O(:),Y1O(:),Z1O(:),P1O(:) 
	REAL (KIND=8) , ALLOCATABLE , TARGET , SAVE :: 
     $                              X2O(:),Y2O(:),Z2O(:),P2O(:)
	REAL (KIND=8) , ALLOCATABLE , TARGET , SAVE :: 
     $                              X3O(:),Y3O(:),Z3O(:),P3O(:)
	REAL (KIND=8) , ALLOCATABLE , TARGET , SAVE :: 
     $                              X4O(:),Y4O(:),Z4O(:),P4O(:)
C
	CONTAINS
C
	SUBROUTINE ALLOC_POSI
C
        ALLOCATE (X1O(NPTS1))	 ; X1O(:) = 0.0
        ALLOCATE (Y1O(NPTS1))	 ; Y1O(:) = 0.0
        ALLOCATE (Z1O(NPTS1))	 ; Z1O(:) = 0.0
        ALLOCATE (P1O(NPTS1))	 ; P1O(:) = 0.0
        ALLOCATE (X2O(NPTS2))	 ; X2O(:) = 0.0
        ALLOCATE (Y2O(NPTS2))	 ; Y2O(:) = 0.0
        ALLOCATE (Z2O(NPTS2))	 ; Z2O(:) = 0.0
        ALLOCATE (P2O(NPTS2))	 ; P2O(:) = 0.0
        ALLOCATE (X3O(NPTS3))	 ; X3O(:) = 0.0
        ALLOCATE (Y3O(NPTS3))	 ; Y3O(:) = 0.0
        ALLOCATE (Z3O(NPTS3))	 ; Z3O(:) = 0.0
        ALLOCATE (P3O(NPTS3))	 ; P3O(:) = 0.0
        ALLOCATE (X4O(NPTS4))	 ; X4O(:) = 0.0
        ALLOCATE (Y4O(NPTS4))	 ; Y4O(:) = 0.0
        ALLOCATE (Z4O(NPTS4))	 ; Z4O(:) = 0.0
        ALLOCATE (P4O(NPTS4))	 ; P4O(:) = 0.0
C
	END SUBROUTINE ALLOC_POSI
C
	SUBROUTINE DEALLOC_POSI
C
	DEALLOCATE (X1O)
	DEALLOCATE (Y1O)
	DEALLOCATE (Z1O)
	DEALLOCATE (P1O)
	DEALLOCATE (X2O)
	DEALLOCATE (Y2O)
	DEALLOCATE (Z2O)
	DEALLOCATE (P2O)
	DEALLOCATE (X3O)
	DEALLOCATE (Y3O)
	DEALLOCATE (Z3O)
	DEALLOCATE (P3O)
	DEALLOCATE (X4O)
	DEALLOCATE (Y4O)
	DEALLOCATE (Z4O)
	DEALLOCATE (P4O)
C
	END SUBROUTINE DEALLOC_POSI
C
	END MODULE POSI_MOD
