	MODULE SVPHOT_MOD
C
C------------------------------------------------------------------------
C 	SAME AS OLD COMMON/SVPHOT
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	IMPLICIT NONE
C
C
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TJM1(:,:,:,:),TJM2(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TJM3(:,:,:,:),TJM4(:,:,:,:)
C
	CONTAINS
C
	SUBROUTINE ALLOC_SVPHOT
C
	USE PARADI_MOD
	USE PHOTO_MOD
C
	ALLOCATE (TJM1(LONM1,LATM1,NIVM1,nphot)) ; TJM1(:,:,:,:) = 0.0
	ALLOCATE (TJM2(LONM2,LATM2,NIVM2,nphot)) ; TJM2(:,:,:,:) = 0.0
	ALLOCATE (TJM3(LONM3,LATM3,NIVM3,nphot)) ; TJM3(:,:,:,:) = 0.0
	ALLOCATE (TJM4(LONM4,LATM4,NIVM4,nphot)) ; TJM4(:,:,:,:) = 0.0
C
	END SUBROUTINE ALLOC_SVPHOT
C
	SUBROUTINE DEALLOC_SVPHOT
C
	DEALLOCATE (TJM1)
	DEALLOCATE (TJM2)
	DEALLOCATE (TJM3)
	DEALLOCATE (TJM4)	
C
	END SUBROUTINE DEALLOC_SVPHOT
C
	END MODULE SVPHOT_MOD
